---
- name: Verify
  hosts: all

  vars:
    schema:
      - name: CentOS
        versions: [8,9]
      - name: Debian
        versions: [all]

  tasks:
    - name: Init platform
      gxmmx.utility.platforms:
        schema: "{{ schema }}"
      ignore_errors: true
      register: platform

    - name: Verify support for CentOS
      ansible.builtin.assert:
        that:
          - "not platform.failed"
        success_msg: Centos supported
      when: ansible_distribution == 'CentOS'
    
    - name: Verify support for Debian
      ansible.builtin.assert:
        that:
          - "not platform.failed"
        success_msg: Debian supported

      when: ansible_distribution == 'Debian'

    - name: Verify support for Rocky
      ansible.builtin.assert:
        that:
          - "platform.failed"
        success_msg: Rocky unsupported
      when: ansible_distribution == 'Rocky'

    - name: Verify contents of variable for Centos 8
      ansible.builtin.assert:
        that:
          - "os_specific_var == 'centos-8'"
        success_msg: Centos 8 variable correct
      when:
        - ansible_distribution == 'CentOS'
        - ansible_distribution_major_version == "8"
    
    - name: Verify contents of variable for Centos 9
      ansible.builtin.assert:
        that:
          - "os_specific_var == 'centos-9'"
        success_msg: Centos 9 variable correct
      when:
        - ansible_distribution == 'CentOS'
        - ansible_distribution_major_version == "9"

    - name: Verify contents of variable for Debian 11
      ansible.builtin.assert:
        that:
          - "os_specific_var == 'debian-all'"
        success_msg: Debian 11 variable correct
      when:
        - ansible_distribution == 'Debian'
        - ansible_distribution_major_version == "11"

    - name: Verify contents of variable for Debian 12
      ansible.builtin.assert:
        that:
          - "os_specific_var == 'debian-12'"
        success_msg: Debian 12 variable correct
      when:
        - ansible_distribution == 'Debian'
        - ansible_distribution_major_version == "12"
